#
#       combobox.py
#       
#       Copyright 2009 Andrew <rugby471@gmail.com>
#       
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#       
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#       
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

import gtk
import os
import logging
from gettext import gettext as _

class ComboboxThemes(gtk.ComboBox):
    def __init__(self, list_store):
        gtk.ComboBox.__init__(self)
        self.set_model(list_store)
        px = gtk.CellRendererPixbuf()
        text = gtk.CellRendererText()
        self.pack_start(px, False)
        self.pack_start(text, False)
        self.add_attribute(px, "pixbuf", 0)
        self.add_attribute(text, "text", 1)

class StoreThemes(gtk.ListStore):
    def __init__(self, themes_dir, data_home):
        gtk.ListStore.__init__(self, gtk.gdk.Pixbuf, str)
        locations = []
        
        for path in [themes_dir + "/", data_home+"/themes/"]:
            if os.path.isdir(path):
                locations.append(path)
                
        self.themes_list_a = []
        self.themes_list_b = []
        for location in locations:
            for items in os.listdir(location):
                if os.path.isdir(location+items):
                    self.themes_list_a.append(items)
                    self.themes_list_b.append(location + items + "/")
                count = 0
        for items in self.themes_list_a:
            theme_icon = self.themes_list_b[count] + items + ".png"
            if os.path.isfile(theme_icon):
                image = gtk.gdk.pixbuf_new_from_file(theme_icon)
            else:
                logging.info(_("The theme '%s' is missing a theme icon.") % items.capitalize())
            count += 1
            self.append((image, items.capitalize()))
        
