#
#       notebook.py
#       
#       Copyright 2009 Andrew <rugby471@gmail.com>
#       
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#       
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#       
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.


import gtk
import os

class NotebookFeatures(gtk.Notebook):
    def __init__(self, feature_list, translation_feature_list, datadir):
        gtk.Notebook.__init__(self)
        count = 0
        self.set_property("tab-pos", gtk.POS_LEFT)
        self.set_property("tab-border", 0)
        self.set_property("tab-hborder", 0)
        self.set_property("tab-vborder", 0)
        self.set_property("border-width", 10)
        self.set_size_request(400, -1)
        
        for feature in feature_list:
            setattr(self, "vbox_%s" % feature, gtk.VBox())
            setattr(self, "scrolledwindow_%s" % feature, gtk.ScrolledWindow())
            setattr(self, "iconview_%s" % feature, gtk.IconView())
            getattr(self, "iconview_%s" % feature).set_orientation(
                                            gtk.ORIENTATION_HORIZONTAL)
            
            getattr(self, "scrolledwindow_%s" % feature).set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
            getattr(self, "scrolledwindow_%s" % feature).add_with_viewport(getattr(self, "iconview_%s" % feature))
            
            setattr(self, "hbox_%s" % feature, gtk.HBox())
            setattr(self, "button_down_%s" % feature, gtk.Button())
            setattr(self, "button_up_%s" % feature, gtk.Button())
            setattr(self, "button_remove_%s" % feature, gtk.Button())
            setattr(self, "arrow_down_%s" % feature, gtk.Arrow(gtk.ARROW_DOWN, gtk.SHADOW_IN))
            setattr(self, "arrow_up_%s" % feature, gtk.Arrow(gtk.ARROW_UP, gtk.SHADOW_IN))
            setattr(self, "image_remove_%s" % feature, gtk.image_new_from_stock(gtk.STOCK_CLEAR, gtk.ICON_SIZE_BUTTON))
            getattr(self, "button_down_%s" % feature).add(getattr(self, "arrow_down_%s" % feature))
            getattr(self, "button_up_%s" % feature).add(getattr(self, "arrow_up_%s" % feature))
            getattr(self, "button_remove_%s" % feature).add(getattr(self, "image_remove_%s" % feature))
            
            getattr(self, "hbox_%s" % feature).pack_start(getattr(self, "button_down_%s" % feature))
            getattr(self, "hbox_%s" % feature).pack_start(getattr(self, "button_up_%s" % feature))
            getattr(self, "hbox_%s" % feature).pack_start(getattr(self, "button_remove_%s" % feature))
            getattr(self, "hbox_%s" % feature).set_homogeneous(True)
            
            getattr(self, "vbox_%s" % feature).pack_start(getattr(self, "scrolledwindow_%s" % feature))
            getattr(self, "vbox_%s" % feature).pack_start(getattr(self, "hbox_%s" % feature), False, False)
            
            setattr(self, "hbox_label_%s" % feature, gtk.HBox())
            setattr(self, "label_%s" % feature, gtk.Label(translation_feature_list[count]))
            setattr(self, "image_%s" % feature, gtk.image_new_from_file(os.path.join(datadir, "labels", "%s.png" % feature)))
            
            
            getattr(self, "hbox_label_%s" % feature).set_homogeneous(True)
            getattr(self, "hbox_label_%s" % feature).pack_start(getattr(self, "image_%s" % feature))
            getattr(self, "hbox_label_%s" % feature).pack_start(getattr(self, "label_%s" % feature))
            
            #Bug in pygtk
            getattr(self, "label_%s" % feature).show()
            getattr(self, "image_%s" % feature).show()
            getattr(self, "hbox_label_%s" % feature).show()
            
            self.append_page(getattr(self, "vbox_%s" % feature), getattr(self, "hbox_label_%s" % feature))
            self.show_all()
            count += 1
        
        
            
            
            
            
            
            
        
        
